<script>
import { GlButton } from '@gitlab/ui'
import LocalStorage from '@/mixins/local-storage'
import { getSearchQuery, setSearchQuery } from '@/assets/get-search-query'
import FilteredSearch from '@/components/search/filtered_search.vue'

export default {
  name: 'MdTableConfig',

  components: {
    GlButton,
    FilteredSearch,
  },

  mixins: [LocalStorage],

  props: {
    columns: {
      type: Array,
      required: true,
    },
    rows: {
      type: Array,
      required: true,
    },
    submitSearch: {
      type: Function,
      required: true,
    },
    clearSearch: {
      type: Function,
      required: true,
    },

    paginationLimit: {
      type: Number,
      required: true,
    },

    exportPath: {
      type: String,
      required: true,
    },

    context: {
      type: String,
      required: true,
    },

    sharePath: {
      type: String,
      required: false,
      default: '',
    },

    namespace: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      searchValue: '',
      paginationOptions: [10, 15, 20, 50, 100].map((limit) => ({
        value: limit,
        text: limit,
      })),
    }
  },

  computed: {
    configurableColumns() {
      return this.columns.filter((column) => !column.nonConfigurable)
    },
  },

  mounted() {
    this.setInitialSearchValue()
  },

  methods: {
    search(term) {
      clearTimeout(this.searchTimeoutId)
      this.searchTimeoutId = setTimeout(() => {
        this.$emit('search', term)
        setSearchQuery(term)
      }, 300)
    },

    trackShareClick() {
      window.glClient?.track('clicked_on_share_button')
    },

    toggleColumn(id, forceShow = false) {
      const index = this.columns.findIndex((column) => column.id === id)

      if (index > -1) {
        if (forceShow && !this.columns[index].hidden) {
          return
        }

        const columns = [...this.columns]
        columns[index].hidden = !columns[index].hidden
        this.$emit('columns-change', columns)
        this.localStorage(
          'columns-visibility',
          columns.map((column) => column.hidden),
        )
      }
    },

    setPaginationLimit(value) {
      this.$emit('pagination-limit-change', value)
      this.localStorage('pagination-limit', value)
    },

    setInitialSearchValue() {
      this.searchValue = getSearchQuery()
    },
  },
}
</script>

<template>
  <div class="mt-4 rounded bg-gray-50">
    <div class="flex flex-col items-end justify-end p-3 sm:flex-row">
      <filtered-search
        :fetched-data="rows"
        :submit-search="submitSearch"
        :clear-search="clearSearch"
        :context="context"
      />
      <div class="gl-mt-4 gl-ml-4 flex shrink space-x-3 sm:mt-0">
        <gl-button :href="exportPath" icon="export">Export</gl-button>
        <gl-button
          v-show="sharePath"
          icon="share"
          :href="sharePath"
          @click="trackShareClick"
        >
          Share
        </gl-button>
      </div>
    </div>
  </div>
</template>
